{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{ Time Complexity : O(log(K) * (N*K)^3 ? }

{ Cautare binara + Bellman Ford (cu coada) }

Program _lanterna_;

const filein = 'lanterna.in';
      fileout = 'lanterna.out';
      MAXN = 50;
      MAXK = 1000;
      infinit = 30000;
      maxdim1 = 63;

type linie = array [0..MAXK] of integer;
     plinie = ^linie;
     pcoada = ^coada;
     coada = record
               i : byte;
               k : integer;
               urm : pcoada;
             end;

var T, W : array [1..MAXN, 1..MAXN] of integer;
    Tmin : array [1..MAXN] of plinie;
    charge : array [1..MAXN] of boolean;
    inq : array[1..MAXN, 0..MAXK] of boolean;
    i, j, p, M, N, K, li, ls : integer;
    TOK, bestK : integer;
    cst, cfin, aux : pcoada;

procedure readdata;
begin
assign(input, filein);
reset(input);
read(N, K);

for i := 1 to N do
  begin
    read(p);
    charge[i] := (p = 1);
  end;

read(M);

for i := 1 to N do
  for j := 1 to N do
    begin
      T[i,j] := infinit;
      W[i,j] := MAXK + 1;
    end;

for p := 1 to m do
  begin
    read(i, j);
    read(T[i,j], W[i,j]);
    T[j,i] := T[i,j];
    W[j,i] := W[i,j];
  end;

close(input);

for i := 1 to N do
  begin
    new(Tmin[i]);
  end;
end;

procedure writedata;
begin
assign(output, fileout);
rewrite(output);
writeln(TOK, ' ', bestK);
close(output);
end;

function MinT(kmax : integer) : integer;
var i, j, k, p, q, tN : integer;

begin
for i := 1 to N do
  for j := 0 to kmax do
    begin
      Tmin[i]^[j] := infinit;
    end;

Tmin[1]^[0] := 0;
inq[1, 0] := true;

new(cst);
cst^.i := 1;
cst^.k := 0;
cst^.urm := nil;
cfin := cst;

tN := infinit;

while (cst <> nil) do
  begin
    i := cst^.i;
    k := cst^.k;

    if (Tmin[i]^[k] < tN) then
      for j := 1 to N do
        if (T[i,j] < infinit) and (k + W[i,j] <= kmax) then
          begin
            p := Tmin[i]^[k] + T[i,j];
            q := k + W[i,j];

            if (charge[j]) then
              q := 0;

            if (p < Tmin[j]^[q]) then
              begin
                Tmin[j]^[q] := p;

                if (j = N) and (Tmin[j]^[q] < tN) then
                  tN := Tmin[j]^[q];

                if (not inq[j, q]) and (Tmin[j]^[q] < tN) then
                  begin
                    inq[j, q] := true;

                    new(aux);
                    aux^.i := j;
                    aux^.k := q;
                    aux^.urm := nil;
                    cfin^.urm := aux;
                    cfin := aux;
                  end;
              end;
          end;

    inq[i, k] := false;
    aux := cst;
    cst := cst^.urm;
    dispose(aux);
  end;

MinT := tN;
end;

begin
readdata;

TOK := MinT(K);
bestK := K;

li := 1; ls := K-1;
while (li <= ls) do
  begin
    p := (li + ls) shr 1;

    if (MinT(p) = TOK) then
      begin
        bestK := p;
        ls := p-1;
      end
    else
      li := p+1;
  end;

writedata;
end.